package com.dtstack.flink.example.function;

import com.dtstack.flink.example.bean.Person;
import org.apache.flink.api.common.functions.RichMapFunction;
import org.apache.flink.shaded.jackson2.com.fasterxml.jackson.databind.JsonNode;
import org.apache.flink.shaded.jackson2.com.fasterxml.jackson.databind.ObjectMapper;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.sql.Timestamp;

public class DTStackMap extends RichMapFunction<String, Person> {

    private static final Logger LOG = LoggerFactory.getLogger(DTStackMap.class);
    private final ObjectMapper objectMapper = new ObjectMapper();


    /**
     * 具体的map逻辑代码
     */
    @Override
    public Person map(String value) throws Exception {
        try {
            Person p = new Person();
            JsonNode jsonNode = objectMapper.readTree(value);
            p.setName(jsonNode.get("name").asText());
            p.setAge(jsonNode.get("age").asInt());
            p.setTimestamp(Timestamp.valueOf(jsonNode.get("timestamp").asText()));
            return p;
        } catch (Exception e) {

            LOG.error(e.toString());
        }
        return null;
    }
}
